# scaricatore

![version](https://git.pweapon.org/odo/dl.emersa.it/badges/release.svg 'version')
![status](https://git.pweapon.org/odo/dl.emersa.it/badges/workflows/ci.yaml/badge.svg 'status')

<img src='./static/screen.webp' alt='screen' height=300>

It's a svelte(kit) frontend that uses `yt-dlp` to let the user download things from the web.

## How to Deploy

### Node

0. Install nodejs
1. Download the latest release from the [releases](https://git.pweapon.org/odo/dl.emersa.it/releases) page.
2. Unpack and decompress (`tar xvf build.tar.gz`) the release
3. Then `cd` into it and run: `npm ci` and `npm run build`
4. Copy `.env.example` to `.env`, and add needed variables
5. Run it: `node .`
6. You can also try to configure the systemd unit file inside the `configurations` folder.

### Docker

(currently not supported)

## Development: getting started

- Clone the repo
- Run `npm install` (you have to have node installed)
- Run `npm run download-yt-dlp`
- Copy `.env.example` to `.env`
- Change `.env` to set `YTDLP_PATH` to the yt-dlp binary previously downloaded
- Run `npm run dev`
- Now you can write code

## To do:

- Proper logs (I don't like them, not useful for production build)
- Containerfile for container build
- Source spotify (spotdl)
- Parse URL info without `youtube-dl-exec`
- Dockerfile inside the forgejo release action
